<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}

class Comment {
    /**
     * +----------------------------------------------------------
     * 相关数据
     * +----------------------------------------------------------
     */
    function data($module, $item_id, $page_size = 10, $page = 1) {
        $data['module'] = $module;
        $data['item_id'] = $item_id;
        $data['list'] = $this->get_comment_list($module, $item_id, $page_size, $page);
        
        return $data;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取评论列表
     * +----------------------------------------------------------
     */
    function get_comment_list($module, $item_id, $page_size = 10, $page = 1) {
        // 未加入分页条件的SQL语句
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('comment') . " WHERE module = '$module' AND item_id = '$item_id' AND if_show = '1' ORDER BY id DESC";
        
        $limit = $GLOBALS['dou']->pager($sql, $page_size, $page, $GLOBALS['dou']->rewrite_url($module, $item_id));
        
        $sql = $sql . $limit; // 加入分页条件的SQL语句
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $add_time = date("Y-m-d H:i", $row['add_time']);
         
            // 昵称
            $nickname = $GLOBALS['dou']->get_one("SELECT nickname FROM " . $GLOBALS['dou']->table('user') . " WHERE user_id = '$row[user_id]'");
        
            // 获取管理员回复
            $reply = $GLOBALS['dou']->get_row('comment', 'content, add_time', "reply_id = '$row[id]'");
            if ($reply)
                $reply['add_time'] = date("Y-m-d H:i", $reply['add_time']);

            $comment_list[] = array (
                    "id" => $row['id'],
                    "nickname" => !$row['anonymous'] && $nickname ? $nickname : $GLOBALS['_LANG']['comment_anonymous'],
                    "content" => $row['content'],
                    "img_list" => $GLOBALS['dou']->get_file_list('comment', $row['order_item_id'], 'gallery', true),
                    "star_box" => $this->star_box($row['star']),
                    "add_time" => $add_time,
                    "reply" => $reply
            );
        }
        
        return $comment_list;
    }

    /**
     * +----------------------------------------------------------
     * 星级
     * +----------------------------------------------------------
     */
    function star_box($star) {
        for ($i = 1; $i <= $star; $i++) {
            $list[] = $i;
        }
        
        $star_box['list'] = $list;
        $star_box['number'] = $star;
     
        return $star_box;
    }

    /**
     * +----------------------------------------------------------
     * 防灌水
     * +----------------------------------------------------------
     */
    function is_water($ip) {
        $unread_messages = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('comment') . " WHERE ip = '$ip' AND if_read = 0 AND reply_id = 0");

        // 如果管理员未回复的评论数量大于1
        if ($unread_messages >= '1')
            return true;
    }

    /**
     * +----------------------------------------------------------
     * 检查是否包含中文字符且长度符合要求
     * +----------------------------------------------------------
     */
    function check_comment($value, $length) {
        $check_chinese = $GLOBALS['_CFG']['input_must_include_chinese'] ? $GLOBALS['check']->if_include_chinese($value) : true;

        if ($check_chinese && $GLOBALS['check']->length($value, $length)) {
            return true;
        }
    }

    /**
     * +----------------------------------------------------------
     * 验证订单商品评论权限
     * +----------------------------------------------------------
     */
    function check_permission($module, $item_id, $order_item_id = '', $user_id = '') {
        global $_GLOBAL_USER, $_PARAM;
     
        // 如果来自小程序，就需要手动传入user_id
        $user_id = $user_id ? $user_id : $_GLOBAL_USER['user_id'];
     
        // 判断是否评论过该项目
        if ($GLOBALS['dou']->value_exist('comment', 'item_id', $item_id, "module = '$module'"))
           return $GLOBALS['_LANG']['comment_exist_item'];
        
        if ((!$_PARAM['comment_allow_no_order'] || !isset($_PARAM['comment_allow_no_order'])) && $order_item_id) {
           // 判断订单项目是否存在
           if (!$GLOBALS['dou']->value_exist('order_item', 'id', $order_item_id, "user_id = '$user_id'"))
               return $GLOBALS['_LANG']['comment_no_allow_item'];

           // 判断订单项目是否可以评论
           if ($GLOBALS['dou']->value_exist('order_item', 'id', $order_item_id, "comment = '1'"))
               return $GLOBALS['_LANG']['comment_no_allow_item'];

           // 判断订单项目是否已经评论
           if ($GLOBALS['dou']->value_exist('comment', 'order_item_id', $order_item_id))
               return $GLOBALS['_LANG']['comment_exist_item'];
        }
    }
}
?>