<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'post|user|insert|filebox';
$subbox = array(
        "module" => 'comment',
        "sub" => $sub
);

if (!defined('REWRITE')) {
    $_CUR = 'comment';
    require (dirname(__FILE__) . '/include/init.php');
}
$smarty->assign('cur', $_CUR);
$smarty->assign('url', $_URL = $dou->dou_sub_url($subbox));

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 需要登录且没有登录的情况
if (!is_array($_GLOBAL_USER))
    $dou->dou_header($_URL['login']);

// 实例化评论功能
include_once (ROOT_PATH . 'include/comment.class.php');
$dou_comment = new Comment();

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
if (!file_exists($aftersale_file_path = ROOT_PATH . 'images/comment/'))
    mkdir($aftersale_file_path, 0777);
$file = new File('images/comment/' . date('Ymd') . '/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板-meta和title信息
$smarty->assign('keywords', $_CFG['site_keywords']);
$smarty->assign('description', $_CFG['site_description']);

// 赋值给模板-导航栏
$smarty->assign('nav_top_list', $dou->get_nav('top'));
$smarty->assign('nav_middle_list', $dou->get_nav('middle', 0, 'comment', 0));
$smarty->assign('nav_bottom_list', $dou->get_nav('bottom'));

// 赋值给模板-数据
$smarty->assign('rec', $rec);
$smarty->assign('link_user_center', $dou_user->link_user_center());
$smarty->assign('if_connect_plugin', $dou->value_exist('plugin', 'plugin_group', 'connect'));

/**
 * +----------------------------------------------------------
 * 评论列表
 * +----------------------------------------------------------
 */
if ($rec == 'user') {
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('comment') . " WHERE user_id = '$_GLOBAL_USER[user_id]' ORDER BY id DESC";

    // 验证并获取合法的分页ID
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $_URL['sub']['user']);

    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $if_show = $row['if_show'] ? $_LANG['display'] : $_LANG['hidden'];
        $add_time = date("Y-m-d H:i", $row['add_time']);
     
        // 获取项目名称
        if ($dou->field_exist($row['module'], 'title')) {
            $item_name = $dou->get_one("SELECT title FROM " . $dou->table($row['module']) . " WHERE id = '" . $row['item_id'] . "'");
        } else {
            $item_name = $dou->get_one("SELECT name FROM " . $dou->table($row['module']) . " WHERE id = '" . $row['item_id'] . "'");
        }
     
        // 昵称
        $nickname = $dou->get_one("SELECT nickname FROM " . $dou->table('user') . " WHERE user_id = '$row[user_id]'");
     
        // 获取管理员回复
        $reply = $GLOBALS['dou']->get_row('comment', 'content, add_time', "reply_id = '$row[id]'");
        if ($reply)
            $reply['add_time'] = date("Y-m-d H:i", $reply['add_time']);
        
        $comment_list[] = array (
                "id" => $row['id'],
                "user" => $row['user_id'] ? $dou->user_basic($row['user_id']) : '',
                "module" => $_LANG['top_add_' . $row['module']],
                "item_name" => $item_name,
                "item_url" => $dou->rewrite_url($row['module'], $row['item_id']),
                "nickname" => !$row['anonymous'] && $nickname ? $nickname : $_LANG['comment_anonymous'],
                "content" => $row['content'],
                "img_list" => $dou->get_file_list('comment', $row['order_item_id'], 'gallery', true),
                "star_box" => $dou_comment->star_box($row['star']),
                "if_show" => $if_show,
                "if_read" => $row['if_read'],
                "ip" => $row['ip'],
                "add_time" => $add_time,
                "reply" => $reply 
        );
    }
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('comment', 'comment_list'));
    $smarty->assign('ur_here', $dou->ur_here('comment', 'comment_list'));
    $smarty->assign('head', $_LANG['comment_list']);
    $smarty->assign('item', $item);
    $smarty->assign('comment_list', $comment_list);
    
    $smarty->display('comment.dwt');
}

/**
 * +----------------------------------------------------------
 * 评论发布
 * +----------------------------------------------------------
 */
elseif ($rec == 'post') {
    $order_item_id = $check->is_number($_REQUEST['order_item_id']) ? $_REQUEST['order_item_id'] : '';
    
    // 判断是否需要登录会员才能评论
    if ($_PARAM['comment_need_login']) {
        if (!is_array($_GLOBAL_USER))
            $dou->dou_header($_URL['login']);
    }
    
    // 权限验证
    if (!$dou_comment->check_permission($order_item_id))
       $dou->dou_header($_URL['user']);
    
    // 项目信息
    $item = $dou->get_row('order_item', '*', "id = '$order_item_id'");
    
    // 上级订单信息
    $item['order'] = $dou->get_row('order', '*', "order_id = '$item[order_id]'");
    $item['order']['add_time'] = date("Y-m-d H:i:s", $item['order']['add_time']);
    $item['order']['order_link'] = $dou->param($_URL['order'] . '&order_sn=' . $item['order']['order_sn']);
 
    // 对应商品信息
    $item['product'] = $dou->get_row($item['module'], '*', "id = '$item[item_id]'");
    $item['product']['image'] = $item['module'] == 'product' ? $dou->dou_file($item['product']['image'], true) : $dou->dou_file($item['product']['image']);
    $item['product']['url'] = $dou->rewrite_url($item['module'], $item['item_id']);
    
    // 赋值给模板-数据
    $smarty->assign('page_title', $dou->page_title('comment', 'comment_post'));
    $smarty->assign('ur_here', $dou->ur_here('comment', 'comment_post'));
    $smarty->assign('head', $_LANG['comment_post']);
    $smarty->assign('item', $item);
    $smarty->assign('order_item_id', $order_item_id);
    $smarty->assign('img_list_html', $dou->get_file_list('comment', $order_item_id, 'gallery'));
    
    $smarty->display('comment.dwt');
}

/**
 * +----------------------------------------------------------
 * 评论提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'insert') {
    // 数据验证
    $captcha = $check->is_captcha($_POST['captcha']) ? strtoupper($_POST['captcha']) : '';
    $module = $check->is_extend_id($_POST['module']) ? $_POST['module'] : '';
    $item_id = $check->is_number($_POST['item_id']) ? $_POST['item_id'] : '';
    $order_item_id = $check->is_number($_REQUEST['order_item_id']) ? $_REQUEST['order_item_id'] : '';

    // 如果限制必须输入中文则修改错误提示
    $include_chinese = $_CFG['input_must_include_chinese'] ? $_LANG['input_must_include_chinese'] : '';
 
    // 验证评论内容
    if ($check->is_illegal_char($_POST['content'])) {
        $wrong['content'] = $_LANG['comment_content'] . $_LANG['illegal_char'];
    } elseif (!$dou_comment->check_comment($_POST['content'], 300)) {
        $wrong['content'] = preg_replace('/d%/Ums', $include_chinese, $_LANG['comment_content_wrong']);
    }
    
    // 权限验证
    if (!$dou_comment->check_permission($order_item_id))
       die('');

    // AJAX验证表单
    if ($_REQUEST['do'] == 'callback') {
        if ($wrong) {
            foreach ($_POST as $key => $value) {
                $wrong_json[$key] = $wrong[$key];
            }
            echo json_encode($wrong_json);
        } else {
            echo json_encode('');
        }
        exit;
    }

    // 初始化数据
    $ip = $dou->get_ip();
    $add_time = time();
 
    // 检查IP是否频繁评论
    if ($dou_comment->is_water($ip))
        $dou->dou_msg($_LANG['comment_is_water'], $_SERVER['HTTP_REFERER']);

    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $wrong_format .= $wrong[$key] . '<br>';
        }
        $dou->dou_msg($wrong_format, $_SERVER['HTTP_REFERER']);
    }

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);    
    
    if ($module && $item_id) {
        $dou->query("INSERT INTO " . $dou->table('comment') . " (id, user_id, order_item_id, module, item_id, content, star, anonymous, ip, add_time)" . " VALUES (NULL, '$_GLOBAL_USER[user_id]', '$order_item_id', '$module', '$item_id', '$_POST[content]', '$_POST[star]', '$_POST[anonymous]', '$ip', '$add_time')");
     
        // 更新订单商品评论状态
        $dou->query("UPDATE " . $dou->table('order_item') . " SET comment = '1' WHERE id = '$order_item_id'");
    }

    $dou->dou_msg($_LANG['comment_success'], $_SERVER['HTTP_REFERER']);
}

/**
 * +----------------------------------------------------------
 * 文件盒子
 * +----------------------------------------------------------
 */
elseif ($rec == 'filebox') {
    // 验证并获取合法的REQUEST
    $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : ''; // 这里用到的是订单ID作为ITEM_ID
    $type = $check->is_letter($_REQUEST['type']) ? $_REQUEST['type'] : '';
    $img_width = $check->is_number($_REQUEST['img_width']) ? $_REQUEST['img_width'] : $_CFG['img_width'];
 
    // 权限验证
    if (!$dou_comment->check_permission($item_id))
       die('');
    
    // 最多只能上传三张图片
    $file_number = $dou->get_one("SELECT COUNT(*) FROM " .$dou->table('file') . " WHERE module = 'comment' AND item_id = '$item_id' AND type = '$type'");
    if ($file_number < 3) {
        $custom_filename = $item_id . '_' . $type . '_' . $dou->create_rand_string('number', 6, time());
        $image = $file->box('comment', $item_id, $type . '_file', $type, $custom_filename, '', '', $img_width, $_CFG['watermark']);
    }

    // 显示已经上传的文件列表
    $html = $dou->get_file_list('comment', $item_id, $type);
    
    echo $html;
}

/**
 * +----------------------------------------------------------
 * 文件删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'filedel') {
    // 验证并获取合法的REQUEST
    $number = preg_match("/^[a-z0-9.]+$/", $_REQUEST['number']) ? $_REQUEST['number'] : '';
    $file_info = $dou->get_row('file', 'module, item_id, type', "number = '$number'");
    
    // 删除文件
    $dou->del_file($number);
 
    // 显示已经上传的文件列表
    $html = $dou->get_file_list($file_info['module'], $file_info['item_id'], $file_info['type']);
    
    echo $html;
}

?>