// index.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    avatarTemp: '', //初始化为空
    checkValue: 1,
    textAreaMaxLen: 200,
    inputValueLength: 0,
    anonymous: 0,
    content: '',
    stars: [0, 1, 2, 3, 4],
    normalSrc: '../../images/star.png',//未选中状态
    selectedSrc: '../../images/star_on.png',//选中状态
    star_unit: 5,//评分
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
        
    wx.setNavigationBarTitle({
      title: app.title.comment
    })
    
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    wx.request({
      url: app.mp_url + 'comment.php',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        order_item_id: options.order_item_id,
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        that.setData({
          item: res.data.item,
          order_item_id: res.data.order_item_id,
          html_file_list: res.data.html_file_list
        })
      },
    })
  },
 
  commentPost: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
      url: app.mp_url + 'comment.php?rec=insert',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        'order_item_id': e.detail.value.order_item_id,
        'content': e.detail.value.content,
        'star': e.detail.value.star,
        'anonymous': e.detail.value.anonymous
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        } else {
          dou.douMsg(res.data.success, '/pages/comment/user')
        }
      }
    })
  },
 
  filebox: function(e) {
    var that = this;
    
    wx.chooseImage ({ //从本地相册选择图片或使用相机拍照
      count: 1, // 默认9
      sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
      sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
      success: function(info) {
        // 返回选定照片的本地文件路径列表，tempFilePath可以作为img标签的src属性显示图片
        var tempFilePaths = info.tempFilePaths;
        
        wx.uploadFile ({
          url: app.mp_url + 'comment.php?rec=filebox',
          filePath: tempFilePaths[0],
          formData: {
            'user_id': wx.getStorageSync('user_id'),
            'shell': wx.getStorageSync('shell'),
            'item_id': e.currentTarget.dataset.item_id
          },
          method:'POST',
          header: {
            'Connect-Key' : wx.getStorageSync('connect_key'),
            'Content-Type': 'application/x-www-form-urlencoded'
          },
          name: 'gallery',
          success: function(res) {
            var data = JSON.parse(res.data) //与wx.request不同，wx.uploadFile返回的是[字符串]，需要自己转为JSON格式
            
            that.setData({
              html_file_list: data.html_file_list
            })
          }
        })
      }
    })
  },
 
  fileDel: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
      url: app.mp_url + 'comment.php?rec=filedel',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        'number': e.currentTarget.dataset.number,
        'item_id': e.currentTarget.dataset.item_id
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        that.setData({
          html_file_list: res.data.html_file_list
        })
      }
    })
  },
 
  bindKeyInput: function (e) {
    if(e.detail.value.length > 200) {
      this.setData({
        inputValueLength:200,
        inputValue: e.detail.value
      })
    } else {
      this.setData({
        inputValueLength:e.detail.value.length,
        inputValue: e.detail.value
      })
    }
  },
 
  selectServer: function (e) {
    var star_unit = e.currentTarget.dataset.star_unit
    if (this.data.star_unit == 1 && e.currentTarget.dataset.star_unit == 1) {//当有一颗星的时候再次点击取消选中
        star_unit = 0;
    }

    this.setData({
        star_unit: star_unit
    })
  },
  
  anonymous(e) {
    if (e.detail.value.includes('1')) {
      console.log('匿名')
      this.setData({
        anonymous: 1
      });
    } else {
      this.setData({
        anonymous: 0,
      });
    }
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  },
 
  radioSex: function(e) {
    this.setData({
      sex: e.detail.value
    })
  }


})