// pages/comment/comment.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    comment_list: [],
    page: 1, // 初始页默认值为1
    nomore: false
  },
 
  onShow: function () {
    var that = this;
    
    // 判断是否登录
    dou.checkLoginState()
    
    // 在tabBar第三个图标中显示购物车数量
    dou.showCartNumber()
  },
 
  onLoad: function(options) {
    var that = this
        
    wx.setNavigationBarTitle({
      title: app.title.comment
    })
   
    // 设置转发标题缓存
    wx.setStorageSync('shareTitle', app.title.comment_list)
    
    // 显示转发按钮
    dou.showShareMenu()
   
    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
    
    that.loadData()
  },

  // 获取数据
  loadData: function(concat = false, page = '') {
    var that = this;
    
    wx.request({
      url: app.mp_url + 'comment.php?rec=user',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        page: page ? page : that.data.page, // 从数据里获取当前页数
      },
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key')
      },
      success: function(res) {
        if (concat) {
          var dataBox = that.data.comment_list; // 从data获取当前datalist数组
          var dataNew = res.data.comment_list; // 从此次请求返回的数据中获取新数组
          
          if (dataNew) {
            dataBox = dataBox.concat(dataNew); // 合并数组
          } else {
            that.setData({
              nomore: true
            })
          }
        } else {
          dataBox = res.data.comment_list;
        }
        
        that.setData({
          comment_list: dataBox,
          loadpage: false
        })
      }
    })
  },
 
  onReachBottom: function () { // 触底开始下一页
    var that = this;
    
    if (!that.data.nomore) {
      var page = that.data.page + 1; // 获取当前页数并+1
    
      that.setData({
        page: page, // 更新当前页数
        loadpage: true,//加载动画的显示
      })

      setTimeout (
        function() { //注意function这里不能缺少
          that.loadData(true); // 重新调用请求获取下一页数据
        },1000
      )
    }
  },

  //图片预览
  previewImage(e) {
    var urls = [e.currentTarget.dataset.image]
    wx.previewImage({
      showmenu: true,
      current: e.currentTarget.dataset.image, // 当前显示图片的链接/路径
      urls: urls // 需要预览的图片链接/路径列表
    });
  },
 
  // 非tabBar的页面，可以带参数
  douNavigateTo: function(e) {
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  }

})