<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$sub = 'user';
$subbox = array(
        "module" => 'comment',
        "sub" => $sub
);

$_CUR = 'comment';
require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
} else {
    if (!in_array($rec, $nomust_login_array)) {
        $data['wrong'] = $_LANG['login_timeout'];
        die(json_encode($data));
    }
}

// 错误提示初始
$data['wrong'] = '';

// 实例化评论功能
include_once (ROOT_PATH . 'include/comment.class.php');
$dou_comment = new Comment();

/**
 * +----------------------------------------------------------
 * 评论发布
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $order_item_id = $check->is_number($_REQUEST['order_item_id']) ? $_REQUEST['order_item_id'] : '';
    
    // 项目信息
    $item = $dou->get_row('order_item', '*', "id = '$order_item_id'");
    
    // 权限验证
    if ($msg = $dou_comment->check_permission($item['module'], $item['item_id'], $order_item_id, $user_id)) {
        // 错误提示
        $data['wrong'] = $msg;
        echo json_encode($data);
        exit;
    }
    
    // 上级订单信息
    $item['order'] = $dou->get_row('order', '*', "order_id = '$item[order_id]'");
    $item['order']['add_time'] = date("Y-m-d H:i:s", $item['order']['add_time']);
    $item['order']['order_link'] = $dou->param($_URL['order'] . '&order_sn=' . $item['order']['order_sn']);
 
    // 对应商品信息
    $item['product'] = $dou->get_row($item['module'], '*', "id = '$item[item_id]'");
    $item['product']['image'] = $item['module'] == 'product' ? $dou->dou_file($item['product']['image'], true) : $dou->dou_file($item['product']['image']);
    $item['product']['url'] = $dou->rewrite_url($item['module'], $item['item_id']);
 
    // 数据封装
    $data['title'] = $_LANG['comment_post'];
    $data['item'] = $item;
    $data['order_item_id'] = $order_item_id;
    $data['html_file_list'] = $dou->get_file_list('comment', $order_item_id, 'gallery', true);
}

/**
 * +----------------------------------------------------------
 * 评论列表
 * +----------------------------------------------------------
 */
elseif ($rec == 'user') {
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('comment') . " WHERE user_id = '$user_id'";

    // 验证并获取合法的分页ID
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $_URL['sub']['user']);

    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $if_show = $row['if_show'] ? $_LANG['display'] : $_LANG['hidden'];
        $add_time = date("Y-m-d H:i", $row['add_time']);
     
        // 获取项目名称
        if ($dou->field_exist($row['module'], 'title')) {
            $item_name = $dou->get_one("SELECT title FROM " . $dou->table($row['module']) . " WHERE id = '" . $row['item_id'] . "'");
        } else {
            $item_name = $dou->get_one("SELECT name FROM " . $dou->table($row['module']) . " WHERE id = '" . $row['item_id'] . "'");
        }
     
        // 昵称
        $nickname = $dou->get_one("SELECT nickname FROM " . $dou->table('user') . " WHERE user_id = '$row[user_id]'");
     
        // 获取管理员回复
        $reply = $GLOBALS['dou']->get_row('comment', 'content, add_time', "reply_id = '$row[id]'");
        if ($reply)
            $reply['add_time'] = date("Y-m-d H:i", $reply['add_time']);
        
        $comment_list[] = array (
                "id" => $row['id'],
                "user" => $row['user_id'] ? $dou->user_basic($row['user_id']) : '',
                "module" => $_LANG['top_add_' . $row['module']],
                "item_name" => $item_name,
                "item_url" => $dou->rewrite_url($row['module'], $row['item_id']),
                "nickname" => !$row['anonymous'] && $nickname ? $nickname : $_LANG['comment_anonymous'],
                "content" => $row['content'],
                "img_list" => $dou->get_file_list('comment', $row['order_item_id'], 'gallery', true),
                "star_box" => $dou_comment->star_box($row['star']),
                "if_show" => $if_show,
                "if_read" => $row['if_read'],
                "ip" => $row['ip'],
                "add_time" => $add_time,
                "reply" => $reply 
        );
    }
 
    // 数据封装
    $data['title'] = $_LANG['comment'];
    $data['item'] = $item;
    $data['comment_list'] = $comment_list;
}

/**
 * +----------------------------------------------------------
 * 评论提交
 * +----------------------------------------------------------
 */
elseif ($rec == 'insert') {
    // 数据验证
    $order_item_id = $check->is_number($_REQUEST['order_item_id']) ? $_REQUEST['order_item_id'] : '';
    $module = $check->is_extend_id($_REQUEST['module']) ? $_REQUEST['module'] : '';
    $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : '';

    // 验证评论内容
    if (empty($_POST['content']) || $check->is_illegal_char($_POST['content']))
        $wrong = $_LANG['comment_content_wrong'];
    
    // 权限验证
    if ($msg = $dou_comment->check_permission($module, $item_id, $order_item_id, $user_id))
        $wrong = $msg;

    // 错误提示
    $data['wrong'] = $wrong;
    if ($data['wrong']) {
        echo json_encode($data);
        exit;
    }

    // 初始化数据
    $ip = $dou->get_ip();
    $add_time = time();
 
    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);    
    
    $dou->query("INSERT INTO " . $dou->table('comment') . " (id, user_id, order_item_id, module, item_id, content, star, anonymous, ip, add_time)" . " VALUES (NULL, '$user_id', '$order_item_id', '$order_item[module]', '$order_item[item_id]', '$_POST[content]', '$_POST[star]', '$_POST[anonymous]', '$ip', '$add_time')");

    // 更新订单商品评论状态
    $dou->query("UPDATE " . $dou->table('order_item') . " SET comment = '1' WHERE id = '$order_item_id'");

    $data['success'] = $_LANG['comment'] . $_LANG['success'];
}

/**
 * +----------------------------------------------------------
 * 文件盒子
 * +----------------------------------------------------------
 */
elseif ($rec == 'filebox') {
    // 图片上传
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/aftersale/' . date('Ymd') . '/'); // 实例化类文件(文件上传路径，结尾加斜杠)
 
    // 验证并获取合法的REQUEST
    $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : ''; // 这里用到的是订单ID作为ITEM_ID
 
    // 先验证该订单是否属于该会员
    if (!$dou_comment->check_permission($item_id, $user_id)) {
        $data['html_file_list'] = array();
    } else {
        // 最多只能上传三张图片
        $file_number = $dou->get_one("SELECT COUNT(*) FROM " .$dou->table('file') . " WHERE module = 'comment' AND item_id = '$item_id' AND type = 'gallery'");
        if ($file_number < 3) {
            // 文件上传盒子
            $custom_filename = $item_id . '_' . $dou->create_rand_string('letter', 6, date('Ymd'));
            $image = $file->box('comment', $item_id, 'gallery', 'gallery', $custom_filename);
        }

        // 显示已经上传的文件列表
        $data['html_file_list'] = $dou->get_file_list('comment', $item_id, 'gallery', true);
    }
}

/**
 * +----------------------------------------------------------
 * 文件删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'filedel') {
    // 验证并获取合法的REQUEST
    $number = preg_match("/^[a-z0-9.]+$/", $_REQUEST['number']) ? $_REQUEST['number'] : '';
    $file_info = $dou->get_row('file', 'module, item_id, type', "number = '$number'");
    
    // 删除文件
    $dou->del_file($number);
 
    // 显示已经上传的文件列表
    $data['html_file_list'] = $dou->get_file_list($file_info['module'], $file_info['item_id'], $file_info['type'], true);
}

echo json_encode($data);

?>